Index: plugins/tools/defaulttools/kis_tool_move.cc
===================================================================
--- plugins/tools/defaulttools/kis_tool_move.cc	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_move.cc	(working copy)
@@ -56,7 +56,6 @@
         :  KisTool(canvas, KisCursor::moveCursor())
 {
     setObjectName("tool_move");
-    m_dragging = false;
     m_optionsWidget = 0;
 }
 
@@ -112,16 +111,22 @@
     return 0;
 }
 
-void KisToolMove::mousePressEvent(KoPointerEvent *e)
+void KisToolMove::mousePressEvent(KoPointerEvent *event)
 {
-    if (canvas() && e->button() == Qt::LeftButton) {
-        QPointF pos = convertToPixelCoord(e);
+    if(PRESS_CONDITION_OM(event, KisTool::HOVER_MODE,
+                          Qt::LeftButton,
+                          Qt::ControlModifier | Qt::ShiftModifier)) {
 
+        setMode(KisTool::PAINT_MODE);
+
         KisNodeSP node;
         KisImageWSP image = currentImage();
         if (!image || !image->rootLayer() || image->rootLayer()->childCount() == 0) {
             return;
         }
+
+        QPointF pos = convertToPixelCoord(event);
+
         // shortcut: if the pixel at projection is transparent, it's all transparent
         const KoColorSpace* cs = image->projection()->colorSpace();
         KoColor color(cs);
@@ -129,9 +134,10 @@
 
         KisSelectionSP selection = currentSelection();
 
-        if (cs->opacityU8(color.data()) == OPACITY_TRANSPARENT_U8
-                || m_optionsWidget->radioSelectedLayer->isChecked()
-                || e->modifiers() == Qt::ControlModifier) {
+        if (cs->opacityU8(color.data()) == OPACITY_TRANSPARENT_U8 ||
+            m_optionsWidget->radioSelectedLayer->isChecked() ||
+            event->modifiers() == Qt::ControlModifier) {
+
             node = currentNode();
         } else {
 
@@ -140,7 +146,7 @@
             node = findNode(node, pos.x(), pos.y());
 
             // if there is a selection, we cannot move the group
-            if (node && !selection && (m_optionsWidget->radioGroup->isChecked() || e->modifiers() == (Qt::ControlModifier | Qt::ShiftModifier))) {
+            if (node && !selection && (m_optionsWidget->radioGroup->isChecked() || event->modifiers() == (Qt::ControlModifier | Qt::ShiftModifier))) {
                 node = node->parent();
             }
         }
@@ -153,7 +159,6 @@
         currentImage()->undoAdapter()->beginMacro(i18n("Move"));
 
         if (selection && !selection->isTotallyUnselected(image->bounds()) && !selection->isDeselected()) {
-            //selection->convertToQImage(0).save("selection.png");
             // Create a temporary layer with the contents of the selection of the current layer.
             Q_ASSERT(!node->inherits("KisGroupLayer"));
 
@@ -207,20 +212,21 @@
             m_targetLayer = 0;
         }
 
-        m_dragging = true;
-        m_dragStart = QPoint(static_cast<int>(pos.x()), static_cast<int>(pos.y()));
         m_layerStart.setX(node->x());
         m_layerStart.setY(node->y());
         m_layerPosition = m_layerStart;
+        m_dragStart = pos.toPoint();
     }
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
-void KisToolMove::mouseMoveEvent(KoPointerEvent *e)
+void KisToolMove::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (canvas() && m_dragging) {
-        QPointF posf = convertToPixelCoord(e);
-        QPoint pos = QPoint(static_cast<int>(posf.x()), static_cast<int>(posf.y()));
-        if ((e->modifiers() & Qt::AltModifier) || (e->modifiers() & Qt::ControlModifier)) {
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
+        QPoint pos = convertToPixelCoord(event).toPoint();
+        if ((event->modifiers() & Qt::AltModifier) || (event->modifiers() & Qt::ControlModifier)) {
             if (fabs(static_cast<double>(pos.x() - m_dragStart.x())) > fabs(static_cast<double>(pos.y() - m_dragStart.y())))
                 pos.setY(m_dragStart.y());
             else
@@ -230,26 +236,31 @@
 
         notifyModified();
     }
+    else {
+        KisTool::mouseMoveEvent(event);
+    }
 }
 
-void KisToolMove::mouseReleaseEvent(KoPointerEvent *e)
+void KisToolMove::mouseReleaseEvent(KoPointerEvent *event)
 {
-    if (m_dragging) {
-        if (canvas() && e->button() == Qt::LeftButton) {
-            QPointF pos = convertToPixelCoord(e);
-            if (m_selectedNode) {
-                drag(QPoint(static_cast<int>(pos.x()), static_cast<int>(pos.y())));
-                m_dragging = false;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
 
-                QUndoCommand *cmd = new KisNodeMoveCommand(m_selectedNode, m_layerStart, m_layerPosition);
-                Q_CHECK_PTR(cmd);
+        if (m_selectedNode) {
+            QPoint pos = convertToPixelCoord(event).toPoint();
+            drag(pos);
 
-                canvas()->addCommand(cmd);
-                currentImage()->undoAdapter()->endMacro();
-            }
-            currentImage()->setModified();
+            QUndoCommand *cmd = new KisNodeMoveCommand(m_selectedNode, m_layerStart, m_layerPosition);
+            Q_CHECK_PTR(cmd);
+
+            canvas()->addCommand(cmd);
+            currentImage()->undoAdapter()->endMacro();
         }
+        currentImage()->setModified();
     }
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 void KisToolMove::drag(const QPoint& original)
Index: plugins/tools/defaulttools/kis_tool_move.h
===================================================================
--- plugins/tools/defaulttools/kis_tool_move.h	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_move.h	(working copy)
@@ -77,7 +77,6 @@
     QPoint m_dragStart;
     QPoint m_layerStart;
     QPoint m_layerPosition;
-    bool m_dragging;
     KisNodeSP m_selectedNode;
     KisNodeSP m_targetLayer;
     KisSelectionSP m_selection;
Index: plugins/tools/defaulttools/kis_tool_fill.cc
===================================================================
--- plugins/tools/defaulttools/kis_tool_fill.cc	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_fill.cc	(working copy)
@@ -172,35 +172,39 @@
     return true;
 }
 
-void KisToolFill::mousePressEvent(KoPointerEvent *e)
+void KisToolFill::mousePressEvent(KoPointerEvent *event)
 {
-    QPointF pos = convertToPixelCoord(e);
-    m_startPos = pos;
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
+
+        setMode(KisTool::PAINT_MODE);
+
+        m_startPos = convertToPixelCoord(event).toPoint();
+    }
+    else {
+        KisToolPaint::mousePressEvent(event);
+    }
 }
 
-void KisToolFill::mouseReleaseEvent(KoPointerEvent *e)
+void KisToolFill::mouseReleaseEvent(KoPointerEvent *event)
 {
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
 
-    if (!canvas()) return;
-    if (!currentNode() || currentNode()->systemLocked()) return;
-    if (!currentImage() || !currentNode()->paintDevice()) return;
-    if (e->button() == Qt::LeftButton) {
-        setCurrentNodeLocked(true);
-        int x, y;
+        if (!currentNode() || currentNode()->systemLocked() ||
+            !currentImage()->bounds().contains(m_startPos)) {
 
-        x = static_cast<int>(m_startPos.x());
-        y = static_cast<int>(m_startPos.y());
-
-        if (!currentImage()->bounds().contains(x, y)) {
             return;
         }
 
-        flood(x, y);
+        setCurrentNodeLocked(true);
+        flood(m_startPos.x(), m_startPos.y());
         setCurrentNodeLocked(false);
         notifyModified();
-    } else {
-        KisToolPaint::mouseReleaseEvent(e);
     }
+    else {
+        KisToolPaint::mouseReleaseEvent(event);
+    }
 }
 
 QWidget* KisToolFill::createOptionWidget()
Index: plugins/tools/defaulttools/kis_tool_fill.h
===================================================================
--- plugins/tools/defaulttools/kis_tool_fill.h	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_fill.h	(working copy)
@@ -63,7 +63,7 @@
     virtual void slotSetFillSelection(bool);
 
 private:
-    QPointF m_startPos;
+    QPoint m_startPos;
     int m_threshold;
     qint32 m_depth;
     quint8* m_oldColor, *m_color;
Index: plugins/tools/defaulttools/kis_tool_line.h
===================================================================
--- plugins/tools/defaulttools/kis_tool_line.h	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_line.h	(working copy)
@@ -62,8 +62,6 @@
 
 private:
 
-    bool m_dragging;
-
     QPointF m_startPos;
     QPointF m_endPos;
 
Index: plugins/tools/defaulttools/kis_tool_gradient.h
===================================================================
--- plugins/tools/defaulttools/kis_tool_gradient.h	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_gradient.h	(working copy)
@@ -89,8 +89,6 @@
 
     QPointF straightLine(QPointF point);
 
-    bool m_dragging;
-
     QPointF m_startPos;
     QPointF m_endPos;
 
Index: plugins/tools/defaulttools/kis_tool_measure.cc
===================================================================
--- plugins/tools/defaulttools/kis_tool_measure.cc	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_measure.cc	(working copy)
@@ -30,8 +30,8 @@
 #include <kis_debug.h>
 #include <klocale.h>
 
-
 #include "kis_image.h"
+#include "kis_cursor.h"
 #include "KoPointerEvent.h"
 #include "KoCanvasBase.h"
 
@@ -93,8 +93,7 @@
 
 
 KisToolMeasure::KisToolMeasure(KoCanvasBase * canvas)
-        : KisTool(canvas, QCursor(Qt::CrossCursor)),
-        m_dragging(false)
+    : KisTool(canvas, KisCursor::crossCursor())
 {
     m_startPos = QPointF(0, 0);
     m_endPos = QPointF(0, 0);
@@ -109,8 +108,6 @@
     qreal sx, sy;
     converter.zoom(&sx, &sy);
 
-    if (!currentImage()) return;
-
     gc.scale(sx / currentImage()->xRes(), sy / currentImage()->yRes());
 
     QPen old = gc.pen();
@@ -139,50 +136,60 @@
     gc.setPen(old);
 }
 
-void KisToolMeasure::mousePressEvent(KoPointerEvent *e)
+void KisToolMeasure::mousePressEvent(KoPointerEvent *event)
 {
-    if (!currentImage()) return;
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
 
-    // Erase old temporary lines
-    canvas()->updateCanvas(convertToPt(boundingRect()));
+        setMode(KisTool::PAINT_MODE);
 
-    QPointF pos = convertToPixelCoord(e);
+        // Erase old temporary lines
+        canvas()->updateCanvas(convertToPt(boundingRect()));
 
-    if (e->button() == Qt::LeftButton) {
-        m_dragging = true;
-        m_startPos = pos;
-        m_endPos = pos;
+        m_startPos = convertToPixelCoord(event);
+        m_endPos = m_startPos;
+
+        emit sigDistanceChanged(0.0);
+        emit sigAngleChanged(0.0);
     }
-    emit sigDistanceChanged(0.0);
-    emit sigAngleChanged(0.0);
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
-void KisToolMeasure::mouseMoveEvent(KoPointerEvent *e)
+void KisToolMeasure::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_dragging) {
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
         // Erase old temporary lines
         canvas()->updateCanvas(convertToPt(boundingRect()));
 
-        QPointF pos = convertToPixelCoord(e);
+        QPointF pos = convertToPixelCoord(event);
 
-        if (e->modifiers() & Qt::AltModifier) {
+        if (event->modifiers() == Qt::AltModifier) {
             QPointF trans = pos - m_endPos;
             m_startPos += trans;
             m_endPos += trans;
-        } else
+        } else {
             m_endPos = pos;
+        }
 
         canvas()->updateCanvas(convertToPt(boundingRect()));
         emit sigDistanceChanged(distance());
         emit sigAngleChanged(angle());
     }
+    else {
+        KisTool::mouseMoveEvent(event);
+    }
 }
 
-void KisToolMeasure::mouseReleaseEvent(KoPointerEvent *e)
+void KisToolMeasure::mouseReleaseEvent(KoPointerEvent *event)
 {
-    if (m_dragging && e->button() == Qt::LeftButton) {
-        m_dragging = false;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
     }
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 QWidget* KisToolMeasure::createOptionWidget()
Index: plugins/tools/defaulttools/kis_tool_colorpicker.cc
===================================================================
--- plugins/tools/defaulttools/kis_tool_colorpicker.cc	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_colorpicker.cc	(working copy)
@@ -64,7 +64,6 @@
     m_updateColor = true;
     m_normaliseValues = false;
     m_pickedColor = KoColor();
-    m_colorPicking = false;
     m_toForegroundColor = true;
 }
 
@@ -153,14 +152,10 @@
 
 void KisToolColorPicker::mousePressEvent(KoPointerEvent *event)
 {
-    if (canvas()) {
-        if (event->button() != Qt::LeftButton && event->button() != Qt::RightButton){
-            return;
-        }
+    if(PRESS_CONDITION_WB(event, KisTool::HOVER_MODE,
+                          Qt::LeftButton | Qt::RightButton, Qt::NoModifier)) {
 
-        if (!currentImage()){
-            return;
-        }
+        setMode(KisTool::PAINT_MODE);
 
         bool sampleMerged = m_optionsWidget->cmbSources->currentIndex() == SAMPLE_MERGED;
         if (!sampleMerged) {
@@ -180,40 +175,48 @@
             return;
         }
 
-        m_colorPicking = true;
         m_toForegroundColor = (event->button() == Qt::LeftButton);
-
         pickColor(pos);
         displayPickedColor();
-
     }
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
 void KisToolColorPicker::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_colorPicking){
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
         QPoint pos = convertToIntPixelCoord(event);
         pickColor(pos);
         displayPickedColor();
     }
+    else {
+        KisTool::mouseMoveEvent(event);
+    }
 }
 
-void KisToolColorPicker::mouseReleaseEvent(KoPointerEvent */*event*/)
+void KisToolColorPicker::mouseReleaseEvent(KoPointerEvent *event)
 {
-    if (m_addPalette) {
-        KoColorSetEntry ent;
-        ent.color = m_pickedColor;
-        // We don't ask for a name, too intrusive here
+    if(RELEASE_CONDITION_WB(event, KisTool::PAINT_MODE, Qt::LeftButton | Qt::RightButton)) {
+        setMode(KisTool::HOVER_MODE);
 
-        KoColorSet* palette = m_palettes.at(m_optionsWidget->cmbPalette->currentIndex());
-        palette->add(ent);
+        if (m_addPalette) {
+            KoColorSetEntry ent;
+            ent.color = m_pickedColor;
+            // We don't ask for a name, too intrusive here
 
-        if (!palette->save()) {
-            KMessageBox::error(0, i18n("Cannot write to palette file %1. Maybe it is read-only.", palette->filename()), i18n("Palette"));
+            KoColorSet* palette = m_palettes.at(m_optionsWidget->cmbPalette->currentIndex());
+            palette->add(ent);
+
+            if (!palette->save()) {
+                KMessageBox::error(0, i18n("Cannot write to palette file %1. Maybe it is read-only.", palette->filename()), i18n("Palette"));
+            }
         }
     }
-
-    m_colorPicking = false;
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 void KisToolColorPicker::displayPickedColor()
Index: plugins/tools/defaulttools/kis_tool_colorpicker.h
===================================================================
--- plugins/tools/defaulttools/kis_tool_colorpicker.h	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_colorpicker.h	(working copy)
@@ -72,7 +72,6 @@
     void pickColor(const QPointF& pos);
 
     bool m_toForegroundColor;
-    bool m_colorPicking;
     bool m_updateColor;
     bool m_addPalette;
     bool m_normaliseValues;
Index: plugins/tools/defaulttools/kis_tool_line.cc
===================================================================
--- plugins/tools/defaulttools/kis_tool_line.cc	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_line.cc	(working copy)
@@ -60,8 +60,7 @@
 
 
 KisToolLine::KisToolLine(KoCanvasBase * canvas)
-        : KisToolPaint(canvas, KisCursor::load("tool_line_cursor.png", 6, 6)),
-        m_dragging(false)
+        : KisToolPaint(canvas, KisCursor::load("tool_line_cursor.png", 6, 6))
 {
     setObjectName("tool_line");
 
@@ -80,127 +79,126 @@
 {
     qreal sx, sy;
     converter.zoom(&sx, &sy);
-    if (m_dragging) {
+    if (mode() == KisTool::PAINT_MODE) {
         paintLine(gc, QRect());
     }
 }
 
 
-void KisToolLine::mousePressEvent(KoPointerEvent *e)
+void KisToolLine::mousePressEvent(KoPointerEvent *event)
 {
-    if (!canvas() || !currentImage()) return;
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
 
-    QPointF pos = convertToPixelCoord(e);
+        setMode(KisTool::PAINT_MODE);
 
-    if (e->button() == Qt::LeftButton) {
-        m_dragging = true;
-        m_startPos = pos;
-        m_endPos = pos;
+        m_startPos = convertToPixelCoord(event);
+        m_endPos = m_startPos;
     }
-
-    if (m_dragging == true && (e->button() == Qt::MidButton || e->button() == Qt::RightButton)) {
-        // end painting, if calling the menu or the pop up palette. otherwise there is weird behaviour
-        m_dragging = false;
-        updatePreview();
+    else {
+        KisToolPaint::mousePressEvent(event);
     }
 }
 
 
-void KisToolLine::mouseMoveEvent(KoPointerEvent *e)
+void KisToolLine::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_dragging) {
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
         // First ensure the old temp line is deleted
         updatePreview();
 
-        QPointF pos = convertToPixelCoord(e);
+        QPointF pos = convertToPixelCoord(event);
 
-        if (e->modifiers() & Qt::AltModifier) {
+        if (event->modifiers() == Qt::AltModifier) {
             QPointF trans = pos - m_endPos;
             m_startPos += trans;
             m_endPos += trans;
-        } else if (e->modifiers() & Qt::ShiftModifier) {
+        } else if (event->modifiers() == Qt::ShiftModifier) {
             m_endPos = straightLine(pos);
         } else {
             m_endPos = pos;
         }
         updatePreview();
     }
+    else {
+        KisToolPaint::mouseMoveEvent(event);
+    }
 }
 
-void KisToolLine::mouseReleaseEvent(KoPointerEvent *e)
+void KisToolLine::mouseReleaseEvent(KoPointerEvent *event)
 {
-    if (m_dragging && e->button() == Qt::LeftButton) {
-        m_dragging = false;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
+
         updatePreview();
 
-        if (canvas()) {
+        QPointF pos = convertToPixelCoord(event);
 
-            if (m_startPos == m_endPos) {
-                m_dragging = false;
-                return;
-            }
+        if (event->modifiers() == Qt::AltModifier) {
+            QPointF trans = pos - m_endPos;
+            m_startPos += trans;
+            m_endPos += trans;
+        } else if (event->modifiers() == Qt::ShiftModifier) {
+            m_endPos = straightLine(pos);
+        } else {
+            m_endPos = pos;
+        }
 
-            QPointF pos = convertToPixelCoord(e);
+        if (m_startPos == m_endPos) {
+            return;
+        }
 
-            if ((e->modifiers() & Qt::ShiftModifier) == Qt::ShiftModifier) {
-                m_endPos = straightLine(pos);
-            } else {
-                m_endPos = pos;
-            }
-
 #ifdef ENABLE_RECORDING
-            if (image()) {
-                KisRecordedPathPaintAction linePaintAction(KisNodeQueryPath::absolutePath(currentNode()), currentPaintOpPreset());
-                setupPaintAction(&linePaintAction);
-                linePaintAction.addLine(m_startPos, m_endPos);
-                image()->actionRecorder()->addAction(linePaintAction);
-            }
+        if (image()) {
+            KisRecordedPathPaintAction linePaintAction(KisNodeQueryPath::absolutePath(currentNode()), currentPaintOpPreset());
+            setupPaintAction(&linePaintAction);
+            linePaintAction.addLine(m_startPos, m_endPos);
+            image()->actionRecorder()->addAction(linePaintAction);
+        }
 #endif
 
-            if (!currentNode()->inherits("KisShapeLayer")) {
-                KisPaintDeviceSP device;
+        if (!currentNode()->inherits("KisShapeLayer")) {
+            KisPaintDeviceSP device;
 
-                if (currentNode() && (device = currentNode()->paintDevice())) {
-                    delete m_painter;
-                    m_painter = new KisPainter(device, currentSelection());
-                    Q_CHECK_PTR(m_painter);
+            if (currentNode() && (device = currentNode()->paintDevice())) {
+                delete m_painter;
+                m_painter = new KisPainter(device, currentSelection());
+                Q_CHECK_PTR(m_painter);
 
-                    m_painter->beginTransaction(i18nc("a straight drawn line", "Line"));
-                    
-                    setupPainter(m_painter);
-                    
-                    m_painter->paintLine(m_startPos, m_endPos);
+                m_painter->beginTransaction(i18nc("a straight drawn line", "Line"));
+                setupPainter(m_painter);
+                m_painter->paintLine(m_startPos, m_endPos);
 
-                    QRegion dirtyRegion = m_painter->dirtyRegion();
-                    device->setDirty(dirtyRegion);
-                    notifyModified();
+                QRegion dirtyRegion = m_painter->dirtyRegion();
+                m_painter->endTransaction(image()->undoAdapter());
 
+                device->setDirty(dirtyRegion);
+                notifyModified();
 
-                    m_painter->endTransaction(image()->undoAdapter());
-                    delete m_painter;
-                    m_painter = 0;
-                }
+                delete m_painter;
+                m_painter = 0;
             }
-            else {
-                KoPathShape* path = new KoPathShape();
-                path->setShapeId(KoPathShapeId);
+        }
+        else {
+            KoPathShape* path = new KoPathShape();
+            path->setShapeId(KoPathShapeId);
 
-                QTransform resolutionMatrix;
-                resolutionMatrix.scale(1 / currentImage()->xRes(), 1 / currentImage()->yRes());
-                path->moveTo(resolutionMatrix.map(m_startPos));
-                path->lineTo(resolutionMatrix.map(m_endPos));
-                path->normalize();
+            QTransform resolutionMatrix;
+            resolutionMatrix.scale(1 / currentImage()->xRes(), 1 / currentImage()->yRes());
+            path->moveTo(resolutionMatrix.map(m_startPos));
+            path->lineTo(resolutionMatrix.map(m_endPos));
+            path->normalize();
 
-                KoLineBorder* border = new KoLineBorder(1.0, currentFgColor().toQColor());
-                path->setBorder(border);
+            KoLineBorder* border = new KoLineBorder(1.0, currentFgColor().toQColor());
+            path->setBorder(border);
 
-                QUndoCommand * cmd = canvas()->shapeController()->addShape(path);
-                canvas()->addCommand(cmd);
-            }
+            QUndoCommand * cmd = canvas()->shapeController()->addShape(path);
+            canvas()->addCommand(cmd);
         }
-    } else {
-        KisToolPaint::mouseReleaseEvent(e);
     }
+    else {
+        KisToolPaint::mouseReleaseEvent(event);
+    }
 }
 
 
Index: plugins/tools/selectiontools/kis_tool_select_contiguous.cc
===================================================================
--- plugins/tools/selectiontools/kis_tool_select_contiguous.cc	(revision 1177751)
+++ plugins/tools/selectiontools/kis_tool_select_contiguous.cc	(working copy)
@@ -61,12 +61,11 @@
 {
 }
 
-void KisToolSelectContiguous::mousePressEvent(KoPointerEvent * e)
+void KisToolSelectContiguous::mousePressEvent(KoPointerEvent *event)
 {
-    if (e->button() != Qt::LeftButton)
-        return;
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
 
-    if (canvas() && currentImage()) {
         QApplication::setOverrideCursor(KisCursor::waitCursor());
 
         if (!currentNode())
@@ -76,7 +75,7 @@
         if (!dev || !currentNode()->visible())
             return;
 
-        QPoint pos = convertToIntPixelCoord(e);
+        QPoint pos = convertToIntPixelCoord(event);
         QRect rc = currentImage()->bounds();
         KisFillPainter fillpainter(dev);
         fillpainter.setHeight(rc.height());
@@ -95,6 +94,9 @@
 
         QApplication::restoreOverrideCursor();
     }
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
 void KisToolSelectContiguous::paint(QPainter &painter, const KoViewConverter &converter)
Index: plugins/tools/selectiontools/kis_tool_select_outline.cc
===================================================================
--- plugins/tools/selectiontools/kis_tool_select_outline.cc	(revision 1177751)
+++ plugins/tools/selectiontools/kis_tool_select_outline.cc	(working copy)
@@ -55,7 +55,6 @@
 KisToolSelectOutline::KisToolSelectOutline(KoCanvasBase * canvas)
         : KisToolSelectBase(canvas, KisCursor::load("tool_outline_selection_cursor.png", 5, 5)), m_paintPath(new QPainterPath())
 {
-    m_dragging = false;
 }
 
 KisToolSelectOutline::~KisToolSelectOutline()
@@ -66,22 +65,27 @@
 
 void KisToolSelectOutline::mousePressEvent(KoPointerEvent *event)
 {
-    if (event->button() == Qt::LeftButton) {
-        m_dragging = true;
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
+
+        setMode(KisTool::PAINT_MODE);
+
         m_points.clear();
         m_points.append(convertToPixelCoord(event));
-
         m_paintPath->moveTo(pixelToView(convertToPixelCoord(event)));
     }
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
 void KisToolSelectOutline::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_dragging) {
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
         QPointF point = convertToPixelCoord(event);
         //don't add the point, if the distance is very small
-        if (m_points.size()>0) {
-            QPointF diff = point-m_points.at(m_points.size()-1);
+        if (!m_points.isEmpty()) {
+            QPointF diff = point - m_points.last();
             if(fabs(diff.x())<3 && fabs(diff.y())<3)
                 return;
         }
@@ -89,18 +93,18 @@
         m_points.append(point);
         updateFeedback();
     }
+    else {
+        KisTool::mouseMoveEvent(event);
+    }
 }
 
 void KisToolSelectOutline::mouseReleaseEvent(KoPointerEvent *event)
 {
-    if (!canvas())
-        return;
-
-    if (m_dragging && event->button() == Qt::LeftButton) {
-        m_dragging = false;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
         deactivate();
 
-        if (currentImage() && m_points.count() > 2) {
+        if (m_points.count() > 2) {
             QApplication::setOverrideCursor(KisCursor::waitCursor());
 
             KisCanvas2 * kisCanvas = dynamic_cast<KisCanvas2*>(canvas());
@@ -150,6 +154,9 @@
         delete m_paintPath;
         m_paintPath = new QPainterPath();
     }
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 
@@ -157,7 +164,7 @@
 {
     Q_UNUSED(converter);
 
-    if (m_dragging && m_points.count() > 1) {
+    if (mode() == KisTool::PAINT_MODE && !m_points.isEmpty()) {
             paintToolOutline(&gc, *m_paintPath);
     }
 }
Index: plugins/tools/selectiontools/kis_tool_select_outline.h
===================================================================
--- plugins/tools/selectiontools/kis_tool_select_outline.h	(revision 1177751)
+++ plugins/tools/selectiontools/kis_tool_select_outline.h	(working copy)
@@ -51,7 +51,6 @@
 private:
     void updateFeedback();
 
-    bool m_dragging;
     QPainterPath * m_paintPath;
     vQPointF m_points;
 
Index: plugins/tools/selectiontools/kis_tool_select_similar.cc
===================================================================
--- plugins/tools/selectiontools/kis_tool_select_similar.cc	(revision 1177751)
+++ plugins/tools/selectiontools/kis_tool_select_similar.cc	(working copy)
@@ -91,27 +91,20 @@
 }
 
 
-void KisToolSelectSimilar::mousePressEvent(KoPointerEvent *e)
+void KisToolSelectSimilar::mousePressEvent(KoPointerEvent *event)
 {
-    if (canvas()) {
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
+
         QApplication::setOverrideCursor(KisCursor::waitCursor());
         quint8 opacity = OPACITY_OPAQUE_U8;
 
-        if (e->button() != Qt::LeftButton)
-            return;
-
-        if (!currentImage())
-            return;
-
-        if (!currentNode())
-            return;
-
         KisPaintDeviceSP dev = currentNode()->paintDevice();
 
         if (!dev || !currentNode()->visible())
             return;
 
-        QPointF pos = convertToPixelCoord(e);
+        QPointF pos = convertToPixelCoord(event);
 
         KisCanvas2 * kisCanvas = dynamic_cast<KisCanvas2*>(canvas());
         if (!kisCanvas)
@@ -131,6 +124,9 @@
 
         QApplication::restoreOverrideCursor();
     }
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
 
